#import psyco
#psyco.full()

import pygame
from pygame.locals import *
pygame.init()
screen=pygame.display.set_mode((600,600))

def put_dot(x,y,pixel):
    #rect=pygame.Rect(x,y,2,2)
    pygame.draw.line(screen,pixel[:3],(x,y),(x,y))

def draw_all(bitmap):
    for p in xrange(600*600):
        put_dot(p%600,p/600,bitmap[p])
    pygame.display.flip()


def transparentBitmap():
    return Bitmap()
    #return[(0,0,0,0)for _ in xrange(600*600)]

class Bitmap():
    def __init__(self):
        self.x={}
    def __getitem__(self,key):
        if self.x.has_key(key): 
            return self.x[key]
        else:
            return (0,0,0,0)
    def __setitem__(self,key,value):
        self.x[key]=value
    def keys(self):
        return self.x.keys()

def RNA_to_FUUN(rna):
    bitmaps=[Bitmap()]
    color= [0,0,0,0] #[r,g,b,count]
    opaque=[0,0]     # [opaque,count]
    posx=0
    posy=0
    markx=0
    marky=0
    direction=0      # 0:East 1:South 2:West 3:North
    
    black=  [0,0,0]
    red=    [255,0,0]
    green=  [0,255,0]
    yellow= [255,255,0]
    blue=   [0,0,255]
    magenta=[255,0,255]
    cyan=   [0,255,255]
    white=  [255,255,255]
    log={}
    log["step"]=0
    log["dot"]=0
    log["line"]=0
    log["fill"]=0
    log["addB"]=0
    log["comB"]=0
    log["clip"]=0
    
    for r in rna:
        for event in pygame.event.get():
            if event.type==QUIT:return
        log["step"]+=1
        if r == 'PIPIIIC':addColor(color,black)
        elif r == 'PIPIIIP':addColor(color,red)
        elif r == 'PIPIICC':addColor(color,green)
        elif r == 'PIPIICF':addColor(color,yellow)
        elif r == 'PIPIICP':addColor(color,blue)
        elif r == 'PIPIIFC':addColor(color,magenta)
        elif r == 'PIPIIFF':addColor(color,cyan)
        elif r == 'PIPIIPC':addColor(color,white)
        elif r == 'PIPIIPF':
            opaque[1]+=1
        elif r == 'PIPIIPP':
            opaque[0]+=255
            opaque[1]+=1
        elif r == 'PIIPICP':
            color=[0,0,0,0]
            opaque=[0,0]
        elif r == 'PIIIIIP':
            if direction==0:
                posx=(posx+1)%600
            elif direction==1:
                posy=(posy+1)%600
            elif direction==2:
                posx=(posx-1)%600
            elif direction==3:
                posy=(posy-1)%600
        elif r == 'PCCCCCP':
            direction=(direction-1)%4
        elif r == 'PFFFFFP':
            direction=(direction+1)%4
        elif r == 'PCCIFFP':
            markx=posx
            marky=posy
        elif r == 'PFFICCP':
            log["line"]+=1
            log["dot"]+=line(bitmaps[-1],posx,posy,markx,marky,current_pixel(color,opaque))
        elif r == 'PIIPIIP':
            log["fill"]+=1
            print "fill"
            tryfill(bitmaps[-1],posx,posy,current_pixel(color,opaque))
            print "finish"
        elif r == 'PCCPFFP':
            log["addB"]+=1
            if len(bitmaps)<10:
                print "addBitmap",len(bitmaps)+1
                bitmaps.append(transparentBitmap())
        elif r == 'PFFPCCP':
            log["comB"]+=1
            if len(bitmaps)>=2:
                print"compose"
                bitmap0=bitmaps[-1]
                bitmap1=bitmaps[-2]
                compose(bitmap0,bitmap1,len(bitmaps)==2)
                bitmaps.pop()
                print"finish",len(bitmaps)
        elif r == "PFFICCF":
            log["clip"]+=1
            if len(bitmaps)>=2:
                print"clip"
                bitmap0=bitmaps.pop()
                bitmap1=bitmaps.pop()
                bitmaps.append(clip(bitmap0,bitmap1))
                print"finish",len(bitmaps)
    #print_bitmap(bitmaps[-1],"test_out.bmp")
    #print_bitmaps(bitmaps)
    draw_all(bitmaps[-1])
    
    print log
    while 1:
        for e in pygame.event.get():
            if e.type==QUIT:
                return


def addColor(color,add_color):
    color[0]+=add_color[0]
    color[1]+=add_color[1]
    color[2]+=add_color[2]
    color[3]+=1
    return

def current_pixel(color,opaque):
    c=color[3]
    if c==0:
        c0=c1=c2=0
    else:
        c0=color[0]/c
        c1=color[1]/c
        c2=color[2]/c
    co=opaque[1]
    if co==0:
        o=255
    else:
        o=opaque[0]/co
    return (c0*o/255,c1*o/255,c2*o/255,o)

def line(bitmap,x0,y0,x1,y1,pixel):
    count=0
    dx=x1-x0
    dy=y1-y0
    d=max(abs(dx),abs(dy))
    c=int(dx*dy<=0)
    x=x0*d+(d-c)/2
    y=y0*d+(d-c)/2
    for _ in xrange(d):
        count+=1
        bitmap[(x/d)+600*(y/d)]=pixel
        put_dot(x/d,y/d,pixel)
        x+=dx
        y+=dy
    bitmap[x1+600*y1]=pixel
    put_dot(x1,y1,pixel)
    pygame.display.flip()
    return count+1

def tryfill(bitmap,posx,posy,pixel):
    new=pixel
    old=bitmap[posx+600*posy]
    if new!=old:
        rec=[0 for _ in xrange(600*600)]
        x,y=posx,posy
        rec[0]=x
        rec[1]=y
        i=2
        while i:
            x=rec[i-2]
            y=rec[i-1]
            i-=2
            if bitmap[x+600*y]==old:
                bitmap[x+600*y]=new
                put_dot(x,y,pixel)
                if i>=len(rec)-10:
                    print i
                    rec+=[0 for _ in xrange(600*600)]
                if x>0:
                    rec[i]=x-1
                    rec[i+1]=y
                    i+=2
                if x<599:
                    rec[i]=x+1
                    rec[i+1]=y
                    i+=2
                if y>0:
                    rec[i]=x
                    rec[i+1]=y-1
                    i+=2
                if y<599:
                    rec[i]=x
                    rec[i+1]=y+1
                    i+=2
        pygame.display.flip()
    return

def compose(bitmap0,bitmap1,flag=0):
    for p in bitmap0.keys():
        r0,g0,b0,a0=bitmap0[p]
        r1,g1,b1,a1=bitmap1[p]
        d=255-a0
        pixel=     (r0+r1*d/255,
                    g0+g1*d/255,
                    b0+b1*d/255,
                    a0+a1*d/255)
        bitmap1[p]=pixel
        if flag:
            put_dot(p%600,p/600,pixel)
    if flag:
        pygame.display.flip()
        print"flip!"

def clip(bitmap0,bitmap1):
    bitmap={}
    for p in bitmap0.keys():
        a0=bitmap0[p][3]
        r1,g1,b1,a1=bitmap1[p]
        bitmap[p]=  (r1*a0/255,
                     g1*a0/255,
                     b1*a0/255,
                     a1*a0/255)
    return bitmap

'''
def print_bitmap(bitmap,filename):
    import bmp
    m=[]
    for p in xrange(600*600):
        r,g,b,a=bitmap[p]
        if r>255 or g>255 or b>255:
            r=g=b=0
        m.append("%c%c%c"%(b,g,r))
    header=bmp.make_header(600,600).tostring()
    s=header+"".join(m)
    f=open(filename,"wb")
    f.write(s)
    f.close()
    return

def print_bitmaps(bitmaps):
    i=0
    for bitmap in bitmaps:
        print i
        print_bitmap(bitmap,"outs2/bitmap%s.bmp"%i)
        i+=1
'''

def test():
    f=open(raw_input(),"rb")
    rna=f.read().split()
    f.close()
    RNA_to_FUUN(rna)
    print"END!!"

test()


